#include <stdio.h>
#include <stdlib.h>
#define MAXREP 100000

struct event
{
	int sec,hun;	//seconds,hundredths
	int x,y;
	int mouse;
};
typedef struct event event;

FILE* AVF,TXT;

int ver,mode,w,h,m;
int size;
int* board;
char* name;
event video[MAXREP];

void pause()
{
	printf("Press enter to exit\n");
	while(getchar()!='\n');
}

int readavf()
{
	int i,cur=0;
	unsigned char c,d;
	unsigned char cr[8];
	
	c=fgetc(AVF);					// version
	ver=c;
	
	for(i=0;i<4;++i) c=fgetc(AVF);	// meaningless bytes
	
	c=fgetc(AVF);					// mode
	mode=c-2;
	if(mode==1)	// beg
	{
		w=h=8;m=10;
	}
	else if(mode==2) // int
	{
		w=h=16;m=40;
	}
	else if(mode==3) // exp
	{
		w=30;h=16;m=99;
	}
	else if(mode==4) // cus
	{
		w=(c=fgetc(AVF))+1;
		h=(c=fgetc(AVF))+1;
		m=(c=fgetc(AVF));
		m=m*256+(c=fgetc(AVF));
	}
	else return 0;
	
	board=(int*)malloc(sizeof(int)*w*h);
	for(i=0;i<w*h;++i) board[i]=0;
	for(i=0;i<m;++i)
	{
		c=fgetc(AVF)-1;
		d=fgetc(AVF)-1;
		board[c*w+d]=1;
	}
	
	while(1)
	{
		while((c=fgetc(AVF))!='[');	// search for timestamp
		c=fgetc(AVF);	// should be mode
		if(c-47==mode) break;
	}
	while((c=fgetc(AVF))!=']');	// search for timestamp
	
	for(i=0;i<7;++i) cr[i]=0;
	while(cr[2]!=1)
	{
		cr[0]=cr[1];cr[1]=cr[2];cr[2]=fgetc(AVF);
	}
	for(i=3;i<8;++i) cr[i]=fgetc(AVF);
	
	while(1)
	{
		video[cur].mouse=cr[0];
		video[cur].x=(int)cr[1]*256+cr[3];
		video[cur].y=(int)cr[5]*256+cr[7];
		video[cur].sec=(int)cr[6]*256+cr[2]-1;
		video[cur].hun=cr[4];
		
		if(video[cur].sec<0) break;
		
		for(i=0;i<8;++i) cr[i]=fgetc(AVF);	
		++cur;
	}

	size=cur;
	return 1;
}

void writetxt()
{
	int i,j;
	int curx,cury;
	printf("Version: 0.%d\n",ver);
	printf("Board:\n");
	for(i=0;i<h;++i)
	{
		for(j=0;j<w;++j)
			if(board[i*w+j])
				printf("*");
			else
				printf("0");
		printf("\n");
	}
	printf("Events:\n");
	curx=cury=-1;
	for(i=0;i<size;++i)
	{
		if(video[i].mouse==1 && video[i].x==curx && video[i].y==cury) continue;
		curx=video[i].x;cury=video[i].y;
		printf("%d.%02d ",video[i].sec,video[i].hun);
		if(video[i].mouse==1) 
			printf("mv ");
		else if(video[i].mouse==3) 
			printf("lc ");
		else if(video[i].mouse==5) 
			printf("lr ");
		else if(video[i].mouse==9) 
			printf("rc ");
		else if(video[i].mouse==17) 
			printf("rr ");
		else if(video[i].mouse==33) 
			printf("mc ");
		else if(video[i].mouse==65) 
			printf("mr ");
		printf("%d %d (%d %d)\n",video[i].x/16+1,video[i].y/16+1,video[i].x,video[i].y);
	}
	
}

int main(int argc,char** argv)
{
	if(argc<2)
	{
		printf("Usage: avf2txt <input avf> [nopause]\n");
		pause();
		return 0;
	}
	
	AVF=fopen(argv[1],"rb");
	
	if(!AVF)
	{
		printf("Couldn't open avf\n");
		return 1;
	}
	
	if(!readavf())
	{
		printf("Invalid AVF\n");
		return 1;
	}
	writetxt();
	fclose(AVF);free(board);
	
	if(argc==2) pause();
	return 0;
}
